package addressbook;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;

import com.neocore.httpclient.XMLEncoder;

public class SearchUserInfoBean {

	ConnectXprioriBean xcon = null; // ConnectXprioriBean饹

	/**
	 * 󥹥ȥ饯 ConnectXprioriBean饹ƤӽФXprioriȤ³Ω
	 */
	public SearchUserInfoBean() {
		// XprioriȤ³Ω
		xcon = new ConnectXprioriBean();
	}

	/**
	 * 桼
	 * 
	 * @return 桼
	 */
	public int CountAllUser() {
		// 桼XPath
		String xpath = "count(/ND/user_info/user)";
		// ̤
		String count_xml = xcon.query(xpath);
		// XMLϤ
		Document doc = AddressbookUtils.loadXMLFromString(count_xml);

		return AddressbookUtils.getQResultInteger(doc);
	}

	/**
	 * 桼ꤷ֤顢եåʬ
	 * 
	 * @param start
	 *            ֹ
	 * @param offset
	 *            եå
	 * @return UserBean
	 */
	public UserBean[] getUsers(int start, int offset) {

		// XPathξĤ
		String xpathCondition = "position() >= " + start + " and "
				+ "position() < " + (start + offset);

		// ꤷϰϤuserΡɤXPath䤤碌̤
		String usersXML = xcon.query("/ND/user_info/user[" + xpathCondition
				+ "]");

		// XMLDOM Document
		Document doc = AddressbookUtils.loadXMLFromString(usersXML);
		NodeList usernodeList = doc.getElementsByTagName("user");

		// 桼ĿʬUserBean
		UserBean[] users = new UserBean[usernodeList.getLength()];

		for (int i = 0; i < usernodeList.getLength(); i++) {
			users[i] = new UserBean(usernodeList.item(i));
		}
		return users;
	}

	/**
	 * ꤷIDĥ桼
	 * 
	 * @param id
	 * @return UserBean
	 */
	public UserBean getUserById(String id) {
		// idƱID°ͤuserΡɤXPath䤤碌̤
		String userXML = xcon.query("/ND/user_info/user[@id = "
				+ AddressbookUtils.getXpathConcat(XMLEncoder.xmlEncode(id))
				+ "]");
		// XMLDOM Document
		Document doc = AddressbookUtils.loadXMLFromString(userXML);
		// DOM DocumentƬuserΡɤФUserBean
		UserBean user = new UserBean(doc.getElementsByTagName("user").item(0));
		return user;
	}

	/**
	 * ꤷ̾ȥѥɤĥ桼¸ߤ뤫Ĵ٤
	 * 
	 * @param username
	 * @param password
	 * @return
	 */
	public UserBean getUser(String username, String password) {
		// 桼̾ȥѥɤ˰פuserǤ뤫Ĵ٤
		String userXML = xcon.query("/ND/user_info/user[name = "
				+ AddressbookUtils.getXpathConcat(XMLEncoder
						.xmlEncode(username))
				+ " and password = "
				+ AddressbookUtils.getXpathConcat(XMLEncoder
						.xmlEncode(password)) + "]");

		// XMLDOM Document
		Document doc = AddressbookUtils.loadXMLFromString(userXML);
		// DOM DocumentƬuserΡɤФUserBean
		UserBean user = new UserBean(doc.getElementsByTagName("user").item(0));
		return user;
	}

	/**
	 * ϿƤ桼οID
	 * 
	 * @return
	 */
	public String getNewId() {
		// IDκͤXPath
		String xpath = "max(/ND/user_info/user/@id)";
		// ̤
		String idMax_xml = xcon.query(xpath);
		// XMLϤ
		Document doc = AddressbookUtils.loadXMLFromString(idMax_xml);
		// ͤ+1
		int newIntId = AddressbookUtils.getQResultInteger(doc) + 1;
		// idη
		String newStrId = String.format("%06d", newIntId);
		return newStrId;
	}

	/**
	 * ѥ᡼user
	 * 
	 * @param param
	 * @return
	 */
	public UserBean getUserByParam(ParamBean param) {
		UserBean user = new UserBean();
		// ѥ᡼ξUserBeanꤹ
		user.setID(param.getId());
		user.setName(param.getName());
		user.setPassword(param.getPassword());
		return user;
	}

	/**
	 * Ȥ
	 * 
	 */
	public void logout() {
		xcon.logout();
	}

}
